/* AMX Mod X
*   Hey Kid
*
* (c) Copyright 2007 by VEN
*
* This file is provided as is (no warranties)
*
*     DESCRIPTION
*       This plugin converts unbrekable window that located near T-spawn on de_prodigy
*       into breakable one. Also puts the sprite(picture) of the well known man behind
*       the converted window. You can break the window and read what he is saying!
*
*     CREDITS
*       Basic-Master - i has modified his sprite
*/

#include <amxmodx>
#include <fakemeta>

#define PLUGIN_NAME "Hey Kid"
#define PLUGIN_VERSION "0.1"
#define PLUGIN_AUTHOR "VEN"

#define SPRITE_NAME "sprites/hey_kid.spr"

#define SPRITE_SCALE 0.5

stock const Float:g_sprite_pos[] = {1240.0, 725.0, -320.0}

#define BORDER_GLASS_STRENGTH 100.0

// do not edit anything below

#define MAP_NAME "de_prodigy"

#define BORDER_FUNC_WALL_NUM 4

new g_fwd_spawn

public plugin_precache() {
	new mapname[32]
	get_mapname(mapname, sizeof mapname - 1)
	if (!equal(mapname, MAP_NAME))
		return

	precache_model(SPRITE_NAME)
	g_fwd_spawn = register_forward(FM_Spawn, "forward_spawn")
}

public plugin_init() {
	register_plugin(PLUGIN_NAME, PLUGIN_VERSION, PLUGIN_AUTHOR)
}

public forward_spawn(entity) {
	static string[32], func_wall[] = "func_wall", func_wall_num = 0
	pev(entity, pev_classname, string, sizeof string - 1)
	if (!equal(string, func_wall) || ++func_wall_num != BORDER_FUNC_WALL_NUM)
		return FMRES_IGNORED

	pev(entity, pev_model, string, sizeof string - 1)
	engfunc(EngFunc_RemoveEntity, entity)

	new ent = engfunc(EngFunc_CreateNamedEntity, engfunc(EngFunc_AllocString, "func_breakable"))
	set_pev(ent, pev_rendermode, kRenderTransTexture)
	set_pev(ent, pev_renderamt, 96.0)
	set_pev(ent, pev_health, BORDER_GLASS_STRENGTH)
	engfunc(EngFunc_SetModel, ent, string)
	dllfunc(DLLFunc_Spawn, ent)
	engfunc(EngFunc_SetSize, ent, Float:{1459.0, 811.0, -361.0}, Float:{1697.0, 821.0, -299.0})

	ent = engfunc(EngFunc_CreateNamedEntity, engfunc(EngFunc_AllocString, "env_sprite"))
	engfunc(EngFunc_SetOrigin, ent, g_sprite_pos)
	engfunc(EngFunc_SetModel, ent, SPRITE_NAME)
	set_pev(ent, pev_scale, SPRITE_SCALE)
	dllfunc(DLLFunc_Spawn, ent)

	unregister_forward(FM_Spawn, g_fwd_spawn)

	return FMRES_SUPERCEDE
}
